def generate_permutations_alt(i, available, sol, elements):
    # Базовый вариант
    if i == len(elements):
        print_permutations(sol)  # комплексное решение
    else:
        # Генерация элементов-кандидатов
        for k in range(0, len(elements)):

            # Проверка валидности кандидатов
            if available[k]:

                # Включить кандидата в частное решение
                sol[i] = elements[k]

                # k-й кандидат больше не доступен
                available[k] = False

                # Генерация элемента в позиции i+1
                generate_permutations_alt(i + 1, available,
                                          sol, elements)

                # k-й кандидат снова доступен
                available[k] = True


def generate_permutations_alt_wrapper(elements):
    available = [True] * (len(elements))
    sol = [None] * (len(elements))
    generate_permutations_alt(0, available, sol, elements)


def print_permutations(sol):
    for i in range(0, len(sol)):
        print(sol[i], ' ', end='')
    print()


generate_permutations_alt_wrapper(['a', 'b', 'c'])
